]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Drop support for i586
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2021 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.27" # Version number
29 CORE="163" # Core Level (Filename)
30 SLOGAN="www.ipfire.org" # Software slogan
31 CONFIG_ROOT=/var/ipfire # Configuration rootdir
32 MAX_RETRIES=1 # prefetch/check loop
33 BUILD_IMAGES=1 # Flash and Xen Downloader
34 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
35
36 # Information from Git
37 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38 GIT_TAG="$(git tag | tail -1)" # Git Tag
39 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
40
41 TOOLCHAINVER=20210701
42
43 # use multicore and max compression
44 ZSTD_OPT="-T0 --ultra -22"
45
46 ###############################################################################
47 #
48 # Beautifying variables & presentation & input output interface
49 #
50 ###############################################################################
51
52 # Remember if the shell is interactive or not
53 if [ -t 0 ] && [ -t 1 ]; then
54 INTERACTIVE=true
55 else
56 INTERACTIVE=false
57 fi
58
59 # Sets or adjusts pretty formatting variables
60 resize_terminal() {
61 ## Screen Dimentions
62 # Find current screen size
63 COLUMNS=$(tput cols)
64
65 # When using remote connections, such as a serial port, stty size returns 0
66 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
67 COLUMNS=80
68 fi
69
70 # Measurements for positioning result messages
71 OPTIONS_WIDTH=20
72 TIME_WIDTH=12
73 STATUS_WIDTH=8
74 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
75 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
76
77 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
78 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
79 }
80
81 # Initially setup terminal
82 resize_terminal
83
84 # Call resize_terminal when terminal is being resized
85 trap "resize_terminal" WINCH
86
87 # Define color for messages
88 BOLD="\\033[1;39m"
89 DONE="\\033[1;32m"
90 SKIP="\\033[1;34m"
91 WARN="\\033[1;35m"
92 FAIL="\\033[1;31m"
93 NORMAL="\\033[0;39m"
94
95 # New architecture variables
96 HOST_ARCH="$(uname -m)"
97
98 PWD=$(pwd)
99 BASENAME=$(basename $0)
100
101 # Debian specific settings
102 if [ ! -e /etc/debian_version ]; then
103 FULLPATH=`which $0`
104 else
105 if [ -x /usr/bin/realpath ]; then
106 FULLPATH=`/usr/bin/realpath $0`
107 else
108 echo "ERROR: Need to do apt-get install realpath"
109 exit 1
110 fi
111 fi
112
113 # This is the directory where make.sh is in
114 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
115
116 LOGFILE=$BASEDIR/log/_build.preparation.log
117 export LOGFILE
118 DIR_CHK=$BASEDIR/cache/check
119 mkdir $BASEDIR/log/ 2>/dev/null
120
121 system_processors() {
122 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
123 }
124
125 system_memory() {
126 local key val unit
127
128 while read -r key val unit; do
129 case "${key}" in
130 MemTotal:*)
131 # Convert to MB
132 echo "$(( ${val} / 1024 ))"
133 break
134 ;;
135 esac
136 done < /proc/meminfo
137 }
138
139 configure_build() {
140 local build_arch="${1}"
141
142 if [ "${build_arch}" = "default" ]; then
143 build_arch="$(configure_build_guess)"
144 fi
145
146 case "${build_arch}" in
147 x86_64)
148 BUILDTARGET="${build_arch}-unknown-linux-gnu"
149 CROSSTARGET="${build_arch}-cross-linux-gnu"
150 BUILD_PLATFORM="x86"
151 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
152 ;;
153
154 aarch64)
155 BUILDTARGET="${build_arch}-unknown-linux-gnu"
156 CROSSTARGET="${build_arch}-cross-linux-gnu"
157 BUILD_PLATFORM="arm"
158 CFLAGS_ARCH="-fstack-clash-protection"
159 ;;
160
161 armv7hl)
162 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
163 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
164 BUILD_PLATFORM="arm"
165 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
166 ;;
167
168 armv6l)
169 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
170 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
171 BUILD_PLATFORM="arm"
172 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
173 #RUSTFLAGS="-Ccodegen-units=1"
174 ;;
175
176 riscv64)
177 BUILDTARGET="${build_arch}-unknown-linux-gnu"
178 CROSSTARGET="${build_arch}-cross-linux-gnu"
179 BUILD_PLATFORM="riscv"
180 CFLAGS_ARCH="-fstack-clash-protection"
181 ;;
182
183 *)
184 exiterror "Cannot build for architure ${build_arch}"
185 ;;
186 esac
187
188 # Check if the QEMU helper is available if needed.
189 if qemu_is_required "${build_arch}"; then
190 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
191
192 if [ -n "${qemu_build_helper}" ]; then
193 QEMU_TARGET_HELPER="${qemu_build_helper}"
194 else
195 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
196 fi
197 fi
198
199 BUILD_ARCH="${build_arch}"
200 TOOLS_DIR="/tools_${BUILD_ARCH}"
201
202 # Enables hardening
203 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
204
205 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
206 CXXFLAGS="${CFLAGS}"
207
208 # Determine parallelism
209 # We assume that each process consumes about
210 # 128MB of memory. Therefore we find out how
211 # many processes fit into memory.
212 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
213 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
214
215 local parallelism
216 if [ ${mem_max} -lt ${cpu_max} ]; then
217 parallelism=${mem_max}
218 else
219 parallelism=${cpu_max}
220 fi
221
222 # Use this as default PARALLELISM
223 DEFAULT_PARALLELISM="${parallelism}"
224
225 # Limit lauched ninja build jobs to computed parallel value.
226 NINJAJOBS="${parallelism}"
227
228 # Compression parameters
229 # We use mode 8 for reasonable memory usage when decompressing
230 # but with overall good compression
231 XZ_OPT="-8"
232
233 # We try to use as many cores as possible
234 XZ_OPT="${XZ_OPT} -T0"
235
236 # We need to limit memory because XZ uses too much when running
237 # in parallel and it isn't very smart in limiting itself.
238 # We allow XZ to use up to 70% of all system memory.
239 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
240
241 # XZ memory cannot be larger than 2GB on 32 bit systems
242 case "${build_arch}" in
243 armv*)
244 if [ ${xz_memory} -gt 2048 ]; then
245 xz_memory=2048
246 fi
247 ;;
248 esac
249
250 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
251 }
252
253 configure_build_guess() {
254 case "${HOST_ARCH}" in
255 x86_64)
256 echo "x86_64"
257 ;;
258
259 aarch64)
260 echo "aarch64"
261 ;;
262
263 armv7*|armv6*)
264 echo "armv6l"
265 ;;
266
267 riscv64)
268 echo "riscv64"
269 ;;
270
271 *)
272 exiterror "Cannot guess build architecture"
273 ;;
274 esac
275 }
276
277 stdumount() {
278 umount $BASEDIR/build/sys 2>/dev/null;
279 umount $BASEDIR/build/dev/shm 2>/dev/null;
280 umount $BASEDIR/build/dev/pts 2>/dev/null;
281 umount $BASEDIR/build/dev 2>/dev/null;
282 umount $BASEDIR/build/proc 2>/dev/null;
283 umount $BASEDIR/build/install/mnt 2>/dev/null;
284 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
285 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
286 umount $BASEDIR/build/usr/src/config 2>/dev/null;
287 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
288 umount $BASEDIR/build/usr/src/html 2>/dev/null;
289 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
290 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
291 umount $BASEDIR/build/usr/src/log 2>/dev/null;
292 umount $BASEDIR/build/usr/src/src 2>/dev/null;
293 umount $BASEDIR/build/usr/src 2>/dev/null;
294 umount $BASEDIR/build/tmp 2>/dev/null;
295 }
296
297 now() {
298 date -u "+%s"
299 }
300
301 format_runtime() {
302 local seconds=${1}
303
304 if [ ${seconds} -ge 3600 ]; then
305 printf "%d:%02d:%02d\n" \
306 "$(( seconds / 3600 ))" \
307 "$(( seconds % 3600 / 60 ))" \
308 "$(( seconds % 3600 % 60 ))"
309 elif [ ${seconds} -ge 60 ]; then
310 printf "%d:%02d\n" \
311 "$(( seconds / 60 ))" \
312 "$(( seconds % 60 ))"
313 else
314 printf "%d\n" "${seconds}"
315 fi
316 }
317
318 print_line() {
319 local line="$@"
320
321 printf "%-${LINE_WIDTH}s" "${line}"
322 }
323
324 _print_line() {
325 local status="${1}"
326 shift
327
328 if ${INTERACTIVE}; then
329 printf "${!status}"
330 fi
331
332 print_line "$@"
333
334 if ${INTERACTIVE}; then
335 printf "${NORMAL}"
336 fi
337 }
338
339 print_headline() {
340 _print_line BOLD "$@"
341 }
342
343 print_error() {
344 _print_line FAIL "$@"
345 }
346
347 print_package() {
348 local name="${1}"
349 shift
350
351 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
352 local options="$@"
353
354 local string="${name}"
355 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
356 string="${string} (${version})"
357 fi
358
359 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
360 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
361 }
362
363 print_runtime() {
364 local runtime=$(format_runtime $@)
365
366 if ${INTERACTIVE}; then
367 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
368 else
369 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
370 fi
371 }
372
373 print_status() {
374 local status="${1}"
375
376 local color="${!status}"
377
378 if ${INTERACTIVE}; then
379 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
380 else
381 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
382 fi
383 }
384
385 print_build_stage() {
386 print_headline "$@"
387
388 # end line
389 printf "\n"
390 }
391
392 print_build_summary() {
393 local runtime=$(format_runtime $@)
394
395 print_line "*** Build finished in ${runtime}"
396 print_status DONE
397 }
398
399 exiterror() {
400 stdumount
401 for i in `seq 0 7`; do
402 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
403 losetup -d /dev/loop${i} 2>/dev/null
404 fi;
405 done
406
407 # Dump logfile
408 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
409 echo # empty line
410
411 local line
412 while read -r line; do
413 echo " ${line}"
414 done <<< "$(tail -n30 ${LOGFILE})"
415 fi
416
417 echo # empty line
418
419 local line
420 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
421 print_error "${line}"
422 print_status FAIL
423 done
424
425 exit 1
426 }
427
428 prepareenv() {
429 # Are we running the right shell?
430 if [ -z "${BASH}" ]; then
431 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
432 fi
433
434 if [ -z "${BASH_VERSION}" ]; then
435 exiterror "Not running BASH shell."
436 fi
437
438 # Trap on emergency exit
439 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
440
441 # Checking if running as root user
442 if [ $(id -u) -ne 0 ]; then
443 exiterror "root privileges required for building"
444 fi
445
446 # Checking for necessary temporary space
447 print_line "Checking for necessary space on disk $BASE_DEV"
448 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
449 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
450 if (( 2048000 > $BASE_ASPACE )); then
451 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
452 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
453 print_status FAIL
454 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
455 fi
456 else
457 print_status DONE
458 fi
459
460 # Set umask
461 umask 022
462
463 # Set LFS Directory
464 LFS=$BASEDIR/build
465
466 # Setup environment
467 set +h
468 LC_ALL=POSIX
469 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
470 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
471
472 # Make some extra directories
473 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
474 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
475 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
476 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
477
478 if [ "${ENABLE_RAMDISK}" = "on" ]; then
479 mkdir -p $BASEDIR/build/usr/src
480 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
481
482 mkdir -p ${BASEDIR}/build/tmp
483 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
484 fi
485
486 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
487
488 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
489 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
490
491 # Make all sources and proc available under lfs build
492 mount --bind /dev $BASEDIR/build/dev
493 mount --bind /dev/pts $BASEDIR/build/dev/pts
494 mount --bind /dev/shm $BASEDIR/build/dev/shm
495 mount --bind /proc $BASEDIR/build/proc
496 mount --bind /sys $BASEDIR/build/sys
497 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
498 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
499 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
500 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
501 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
502 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
503 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
504 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
505 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
506
507 # Run LFS static binary creation scripts one by one
508 export CCACHE_DIR=$BASEDIR/ccache
509 export CCACHE_TEMPDIR="/tmp"
510 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
511
512 # Remove pre-install list of installed files in case user erase some files before rebuild
513 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
514
515 # Prepare string for /etc/system-release.
516 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
517
518 case "${GIT_BRANCH}" in
519 core*|beta?|rc?)
520 system_release="${system_release} - ${GIT_BRANCH}"
521 ;;
522 *)
523 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
524 ;;
525 esac
526
527 # Append -dirty tag for local changes
528 if [ "$(git status -s | wc -l)" != "0" ]; then
529 system_release="${system_release}-dirty"
530 fi
531
532 # Export variable
533 SYSTEM_RELEASE="${system_release}"
534
535 # Decide on PAKFIRE_TREE
536 case "${GIT_BRANCH}" in
537 core*)
538 PAKFIRE_TREE="stable"
539 ;;
540 master)
541 PAKFIRE_TREE="testing"
542 ;;
543 *)
544 PAKFIRE_TREE="unstable"
545 ;;
546 esac
547
548 # Setup ccache cache size
549 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
550 }
551
552 enterchroot() {
553 # Install QEMU helper, if needed
554 qemu_install_helper
555
556 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
557
558 PATH="${PATH}" chroot ${LFS} env -i \
559 HOME="/root" \
560 TERM="${TERM}" \
561 PS1="${PS1}" \
562 PATH="${PATH}" \
563 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
564 PAKFIRE_TREE="${PAKFIRE_TREE}" \
565 NAME="${NAME}" \
566 SNAME="${SNAME}" \
567 VERSION="${VERSION}" \
568 CORE="${CORE}" \
569 SLOGAN="${SLOGAN}" \
570 TOOLS_DIR="${TOOLS_DIR}" \
571 CONFIG_ROOT="${CONFIG_ROOT}" \
572 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
573 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
574 RUSTFLAGS="${RUSTFLAGS}" \
575 BUILDTARGET="${BUILDTARGET}" \
576 CROSSTARGET="${CROSSTARGET}" \
577 BUILD_ARCH="${BUILD_ARCH}" \
578 BUILD_PLATFORM="${BUILD_PLATFORM}" \
579 CCACHE_DIR=/usr/src/ccache \
580 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
581 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
582 GOCACHE="/usr/src/ccache/go" \
583 KVER="${KVER}" \
584 XZ_OPT="${XZ_OPT}" \
585 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
586 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
587 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
588 $(fake_environ) \
589 $(qemu_environ) \
590 "$@"
591 }
592
593 entershell() {
594 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
595 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
596 fi
597
598 echo "Entering to a shell inside LFS chroot, go out with exit"
599 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
600
601 if enterchroot bash -i; then
602 stdumount
603 else
604 print_status FAIL
605 exiterror "chroot error"
606 fi
607 }
608
609 lfsmakecommoncheck() {
610 # Script present?
611 if [ ! -f $BASEDIR/lfs/$1 ]; then
612 exiterror "No such file or directory: $BASEDIR/$1"
613 fi
614
615 # Print package name and version
616 print_package $@
617
618 # Check if this package is supported by our architecture.
619 # If no SUP_ARCH is found, we assume the package can be built for all.
620 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
621 # Check if package supports ${BUILD_ARCH} or all architectures.
622 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
623 print_runtime 0
624 print_status SKIP
625 return 1
626 fi
627 fi
628
629 # Script slipped?
630 local i
631 for i in $SKIP_PACKAGE_LIST
632 do
633 if [ "$i" == "$1" ]; then
634 print_status SKIP
635 return 1;
636 fi
637 done
638
639 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
640
641 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
642 MESSAGE="$1\t " download >> $LOGFILE 2>&1
643 if [ $? -ne 0 ]; then
644 exiterror "Download error in $1"
645 fi
646
647 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
648 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
649 if [ $? -ne 0 ]; then
650 exiterror "md5sum error in $1, check file in cache or signature"
651 fi
652
653 return 0 # pass all!
654 }
655
656 lfsmake1() {
657 lfsmakecommoncheck $*
658 [ $? == 1 ] && return 0
659
660 cd $BASEDIR/lfs && env -i \
661 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
662 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
663 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
664 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
665 CFLAGS="${CFLAGS}" \
666 CXXFLAGS="${CXXFLAGS}" \
667 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
668 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
669 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
670 make -f $* \
671 TOOLCHAIN=1 \
672 TOOLS_DIR="${TOOLS_DIR}" \
673 CROSSTARGET="${CROSSTARGET}" \
674 BUILDTARGET="${BUILDTARGET}" \
675 BUILD_ARCH="${BUILD_ARCH}" \
676 BUILD_PLATFORM="${BUILD_PLATFORM}" \
677 LFS_BASEDIR="${BASEDIR}" \
678 ROOT="${LFS}" \
679 KVER="${KVER}" \
680 install >> $LOGFILE 2>&1 &
681
682 if ! wait_until_finished $!; then
683 print_status FAIL
684 exiterror "Building $*"
685 fi
686
687 print_status DONE
688 }
689
690 lfsmake2() {
691 lfsmakecommoncheck $*
692 [ $? == 1 ] && return 0
693
694 local PS1='\u:\w$ '
695
696 enterchroot \
697 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
698 make -f $* \
699 LFS_BASEDIR=/usr/src install" \
700 >> ${LOGFILE} 2>&1 &
701
702 if ! wait_until_finished $!; then
703 print_status FAIL
704 exiterror "Building $*"
705 fi
706
707 print_status DONE
708 }
709
710 ipfiredist() {
711 lfsmakecommoncheck $*
712 [ $? == 1 ] && return 0
713
714 local PS1='\u:\w$ '
715
716 enterchroot \
717 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
718 >> ${LOGFILE} 2>&1 &
719
720 if ! wait_until_finished $!; then
721 print_status FAIL
722 exiterror "Packaging $*"
723 fi
724
725 print_status DONE
726 }
727
728 wait_until_finished() {
729 local pid=${1}
730
731 local start_time=$(now)
732
733 # Show progress
734 if ${INTERACTIVE}; then
735 # Wait a little just in case the process
736 # has finished very quickly.
737 sleep 0.1
738
739 local runtime
740 while kill -0 ${pid} 2>/dev/null; do
741 print_runtime $(( $(now) - ${start_time} ))
742
743 # Wait a little
744 sleep 1
745 done
746 fi
747
748 # Returns the exit code of the child process
749 wait ${pid}
750 local ret=$?
751
752 if ! ${INTERACTIVE}; then
753 print_runtime $(( $(now) - ${start_time} ))
754 fi
755
756 return ${ret}
757 }
758
759 fake_environ() {
760 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
761
762 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
763
764 # Fake kernel version, because some of the packages do not compile
765 # with kernel 3.0 and later.
766 env="${env} UTS_RELEASE=${KVER}-ipfire"
767
768 # Fake machine version.
769 env="${env} UTS_MACHINE=${BUILD_ARCH}"
770
771 echo "${env}"
772 }
773
774 qemu_environ() {
775 local env
776
777 # Don't add anything if qemu is not used.
778 if ! qemu_is_required; then
779 return
780 fi
781
782 # Set default qemu options
783 case "${BUILD_ARCH}" in
784 arm*)
785 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
786
787 env="${env} QEMU_CPU=${QEMU_CPU}"
788 ;;
789 esac
790
791 # Enable QEMU strace
792 #env="${env} QEMU_STRACE=1"
793
794 echo "${env}"
795 }
796
797 qemu_is_required() {
798 local build_arch="${1}"
799
800 if [ -z "${build_arch}" ]; then
801 build_arch="${BUILD_ARCH}"
802 fi
803
804 case "${HOST_ARCH},${build_arch}" in
805 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
806 return 0
807 ;;
808 *)
809 return 1
810 ;;
811 esac
812 }
813
814 qemu_install_helper() {
815 # Do nothing, if qemu is not required
816 if ! qemu_is_required; then
817 return 0
818 fi
819
820 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
821 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
822 fi
823
824 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
825 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
826 fi
827
828
829 if [ -z "${QEMU_TARGET_HELPER}" ]; then
830 exiterror "QEMU_TARGET_HELPER not set"
831 fi
832
833 # Check if the helper is already installed.
834 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
835 return 0
836 fi
837
838 # Try to find a suitable binary that we can install
839 # to the build environment.
840 local file
841 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
842 # file must exist and be executable.
843 [ -x "${file}" ] || continue
844
845 # Must be static.
846 file_is_static "${file}" || continue
847
848 local dirname="${LFS}$(dirname "${file}")"
849 mkdir -p "${dirname}"
850
851 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
852 return 0
853 done
854
855 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
856 }
857
858 qemu_find_build_helper_name() {
859 local build_arch="${1}"
860
861 local magic
862 case "${build_arch}" in
863 aarch64)
864 magic="7f454c460201010000000000000000000200b700"
865 ;;
866 arm*)
867 magic="7f454c4601010100000000000000000002002800"
868 ;;
869 riscv64)
870 magic="7f454c460201010000000000000000000200f300"
871 ;;
872 x86_64)
873 magic="7f454c4602010100000000000000000002003e00"
874 ;;
875 esac
876
877 [ -z "${magic}" ] && return 1
878
879 local file
880 for file in /proc/sys/fs/binfmt_misc/*; do
881 # skip write only register entry
882 [ $(basename "${file}") = "register" ] && continue
883 # Search for the file with the correct magic value.
884 grep -qE "^magic ${magic}$" "${file}" || continue
885
886 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
887
888 [ -n "${interpreter}" ] || continue
889 [ "${interpreter:0:1}" = "/" ] || continue
890 [ -x "${interpreter}" ] || continue
891
892 echo "${interpreter}"
893 return 0
894 done
895
896 return 1
897 }
898
899 file_is_static() {
900 local file="${1}"
901
902 file ${file} 2>/dev/null | grep -q "statically linked"
903 }
904
905 update_language_list() {
906 local path="${1}"
907
908 local lang
909 for lang in ${path}/*.po; do
910 lang="$(basename "${lang}")"
911 echo "${lang%*.po}"
912 done | sort -u > "${path}/LINGUAS"
913 }
914
915 contributors() {
916 local commits name
917
918 git shortlog --summary --numbered | while read -r commits name; do
919 echo "${name}"
920 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
921 }
922
923 update_contributors() {
924 echo -n "Updating list of contributors"
925
926 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
927
928 # Edit contributors into credits.cgi
929 local tmp="$(mktemp)"
930
931 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
932 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
933
934 # Copy back modified content
935 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
936 unlink "${tmp}"
937
938 print_status DONE
939 return 0
940 }
941
942 # Default settings
943 CCACHE_CACHE_SIZE="4G"
944 ENABLE_RAMDISK="auto"
945
946 # Load configuration file
947 if [ -f .config ]; then
948 . .config
949 fi
950
951 # TARGET_ARCH is BUILD_ARCH now
952 if [ -n "${TARGET_ARCH}" ]; then
953 BUILD_ARCH="${TARGET_ARCH}"
954 unset TARGET_ARCH
955 fi
956
957 # Get some information about the host system
958 SYSTEM_PROCESSORS="$(system_processors)"
959 SYSTEM_MEMORY="$(system_memory)"
960
961 if [ -n "${BUILD_ARCH}" ]; then
962 configure_build "${BUILD_ARCH}"
963 else
964 configure_build "default"
965 fi
966
967 # Automatically enable/disable ramdisk usage
968 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
969 # Enable only when the host system has 4GB of RAM or more
970 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
971 ENABLE_RAMDISK="on"
972 fi
973 fi
974
975 buildtoolchain() {
976 local error=false
977 case "${BUILD_ARCH}:${HOST_ARCH}" in
978 # x86_64
979 x86_64:x86_64)
980 # This is working.
981 ;;
982
983 # ARM
984 arvm7hl:armv7hl|armv7hl:armv7l)
985 # These are working.
986 ;;
987
988 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
989 # These are working.
990 ;;
991 armv6l:*)
992 error=true
993 ;;
994 esac
995
996 ${error} && \
997 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
998
999 local gcc=$(type -p gcc)
1000 if [ -z "${gcc}" ]; then
1001 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1002 fi
1003
1004 # Check ${TOOLS_DIR} symlink
1005 if [ -h "${TOOLS_DIR}" ]; then
1006 rm -f "${TOOLS_DIR}"
1007 fi
1008
1009 if [ ! -e "${TOOLS_DIR}" ]; then
1010 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1011 fi
1012
1013 if [ ! -h "${TOOLS_DIR}" ]; then
1014 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1015 fi
1016
1017 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1018 export LOGFILE
1019
1020 lfsmake1 stage1
1021 lfsmake1 binutils PASS=1
1022 lfsmake1 gcc PASS=1
1023 lfsmake1 linux KCFG="-headers"
1024 lfsmake1 glibc
1025 lfsmake1 libxcrypt
1026 lfsmake1 gcc PASS=L
1027 lfsmake1 zlib
1028 lfsmake1 zstd
1029 lfsmake1 binutils PASS=2
1030 lfsmake1 gcc PASS=2
1031 lfsmake1 ccache
1032 lfsmake1 tcl
1033 lfsmake1 expect
1034 lfsmake1 dejagnu
1035 lfsmake1 pkg-config
1036 lfsmake1 ncurses
1037 lfsmake1 bash
1038 lfsmake1 bzip2
1039 lfsmake1 automake
1040 lfsmake1 coreutils
1041 lfsmake1 diffutils
1042 lfsmake1 findutils
1043 lfsmake1 gawk
1044 lfsmake1 gettext
1045 lfsmake1 grep
1046 lfsmake1 gzip
1047 lfsmake1 m4
1048 lfsmake1 make
1049 lfsmake1 patch
1050 lfsmake1 perl
1051 lfsmake1 python3
1052 lfsmake1 sed
1053 lfsmake1 tar
1054 lfsmake1 texinfo
1055 lfsmake1 xz
1056 lfsmake1 bison
1057 lfsmake1 flex
1058 lfsmake1 fake-environ
1059 lfsmake1 strip
1060 lfsmake1 cleanup-toolchain
1061 }
1062
1063 buildbase() {
1064 LOGFILE="$BASEDIR/log/_build.base.log"
1065 export LOGFILE
1066 lfsmake2 stage2
1067 lfsmake2 linux KCFG="-headers"
1068 lfsmake2 man-pages
1069 lfsmake2 glibc
1070 lfsmake2 tzdata
1071 lfsmake2 cleanup-toolchain
1072 lfsmake2 zlib
1073 lfsmake2 zstd
1074 lfsmake2 autoconf
1075 lfsmake2 automake
1076 lfsmake2 libtool
1077 lfsmake2 binutils
1078 lfsmake2 gmp
1079 lfsmake2 mpfr
1080 lfsmake2 libmpc
1081 lfsmake2 libxcrypt
1082 lfsmake2 file
1083 lfsmake2 gcc
1084 lfsmake2 sed
1085 lfsmake2 berkeley
1086 lfsmake2 coreutils
1087 lfsmake2 iana-etc
1088 lfsmake2 m4
1089 lfsmake2 bison
1090 lfsmake2 ncurses
1091 lfsmake2 perl
1092 lfsmake2 readline
1093 lfsmake2 bzip2
1094 lfsmake2 xz
1095 lfsmake2 lzip
1096 lfsmake2 pcre
1097 lfsmake2 pcre2
1098 lfsmake2 gettext
1099 lfsmake2 attr
1100 lfsmake2 acl
1101 lfsmake2 bash
1102 lfsmake2 diffutils
1103 lfsmake2 ed
1104 lfsmake2 findutils
1105 lfsmake2 flex
1106 lfsmake2 gawk
1107 lfsmake2 go
1108 lfsmake2 grep
1109 lfsmake2 groff
1110 lfsmake2 gperf
1111 lfsmake2 gzip
1112 lfsmake2 hostname
1113 lfsmake2 whois
1114 lfsmake2 kbd
1115 lfsmake2 less
1116 lfsmake2 pkg-config
1117 lfsmake2 procps
1118 lfsmake2 make
1119 lfsmake2 man
1120 lfsmake2 net-tools
1121 lfsmake2 patch
1122 lfsmake2 psmisc
1123 lfsmake2 shadow
1124 lfsmake2 sysklogd
1125 lfsmake2 sysvinit
1126 lfsmake2 tar
1127 lfsmake2 texinfo
1128 lfsmake2 util-linux
1129 lfsmake2 vim
1130 lfsmake2 e2fsprogs
1131 }
1132
1133 buildipfire() {
1134 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1135 export LOGFILE
1136 lfsmake2 configroot
1137 lfsmake2 initscripts
1138 lfsmake2 backup
1139 lfsmake2 openssl
1140 lfsmake2 kmod
1141 lfsmake2 udev
1142 lfsmake2 popt
1143 lfsmake2 libedit
1144 lfsmake2 libusb
1145 lfsmake2 libusb-compat
1146 lfsmake2 libpcap
1147 lfsmake2 ppp
1148 lfsmake2 pptp
1149 lfsmake2 unzip
1150 lfsmake2 which
1151 lfsmake2 linux-firmware
1152 lfsmake2 dvb-firmwares
1153 lfsmake2 xr819-firmware
1154 lfsmake2 zd1211-firmware
1155 lfsmake2 rpi-firmware
1156 lfsmake2 intel-microcode
1157 lfsmake2 pcengines-apu-firmware
1158 lfsmake2 bc
1159 lfsmake2 u-boot MKIMAGE=1
1160 lfsmake2 cpio
1161 lfsmake2 mdadm
1162 lfsmake2 dracut
1163 lfsmake2 libaio
1164 lfsmake2 lvm2
1165 lfsmake2 multipath-tools
1166 lfsmake2 freetype
1167 lfsmake2 libmnl
1168 lfsmake2 libnfnetlink
1169 lfsmake2 libnetfilter_queue
1170 lfsmake2 libnetfilter_conntrack
1171 lfsmake2 libnetfilter_cthelper
1172 lfsmake2 libnetfilter_cttimeout
1173 lfsmake2 iptables
1174 lfsmake2 iproute2
1175 lfsmake2 screen
1176 lfsmake2 elfutils
1177
1178 # Kernelbuild ... current we have no platform that need
1179 # multi kernel builds so KCFG is empty
1180 lfsmake2 linux KCFG=""
1181 lfsmake2 rtl8189es KCFG=""
1182 lfsmake2 rtl8812au KCFG=""
1183 lfsmake2 rtl8822bu KCFG=""
1184 lfsmake2 xradio KCFG=""
1185 lfsmake2 xtables-addons KCFG=""
1186 lfsmake2 linux-initrd KCFG=""
1187
1188 lfsmake2 xtables-addons USPACE="1"
1189 lfsmake2 libgpg-error
1190 lfsmake2 libgcrypt
1191 lfsmake2 libassuan
1192 lfsmake2 nettle
1193 lfsmake2 json-c
1194 lfsmake2 libconfig
1195 lfsmake2 libevent
1196 lfsmake2 libevent2
1197 lfsmake2 expat
1198 lfsmake2 apr
1199 lfsmake2 aprutil
1200 lfsmake2 unbound
1201 lfsmake2 gnutls
1202 lfsmake2 libuv
1203 lfsmake2 bind
1204 lfsmake2 dhcp
1205 lfsmake2 dhcpcd
1206 lfsmake2 boost
1207 lfsmake2 linux-atm
1208 lfsmake2 gdbm
1209 lfsmake2 pam
1210 lfsmake2 c-ares
1211 lfsmake2 curl
1212 lfsmake2 tcl
1213 lfsmake2 sqlite
1214 lfsmake2 libffi
1215 lfsmake2 python3
1216 lfsmake2 gdb
1217 lfsmake2 grub
1218 lfsmake2 efivar
1219 lfsmake2 efibootmgr
1220 lfsmake2 libtasn1
1221 lfsmake2 p11-kit
1222 lfsmake2 ca-certificates
1223 lfsmake2 fireinfo
1224 lfsmake2 libnet
1225 lfsmake2 libnl
1226 lfsmake2 libnl-3
1227 lfsmake2 libidn
1228 lfsmake2 nasm
1229 lfsmake2 libarchive
1230 lfsmake2 cmake
1231 lfsmake2 ninja
1232 lfsmake2 meson
1233 lfsmake2 libjpeg
1234 lfsmake2 openjpeg
1235 lfsmake2 libexif
1236 lfsmake2 libpng
1237 lfsmake2 libtiff
1238 lfsmake2 libart
1239 lfsmake2 gd
1240 lfsmake2 slang
1241 lfsmake2 newt
1242 lfsmake2 libsmooth
1243 lfsmake2 libcap
1244 lfsmake2 libcap-ng
1245 lfsmake2 pciutils
1246 lfsmake2 usbutils
1247 lfsmake2 libxml2
1248 lfsmake2 libxslt
1249 lfsmake2 BerkeleyDB
1250 lfsmake2 cyrus-sasl
1251 lfsmake2 openldap
1252 lfsmake2 apache2
1253 lfsmake2 web-user-interface
1254 lfsmake2 flag-icons
1255 lfsmake2 jquery
1256 lfsmake2 bootstrap
1257 lfsmake2 arping
1258 lfsmake2 beep
1259 lfsmake2 libssh
1260 lfsmake2 libinih
1261 lfsmake2 cdrkit
1262 lfsmake2 dosfstools
1263 lfsmake2 exfatprogs
1264 lfsmake2 reiserfsprogs
1265 lfsmake2 liburcu
1266 lfsmake2 xfsprogs
1267 lfsmake2 sysfsutils
1268 lfsmake2 fuse
1269 lfsmake2 ntfs-3g
1270 lfsmake2 ethtool
1271 lfsmake2 fcron
1272 lfsmake2 ExtUtils-PkgConfig
1273 lfsmake2 perl-GD
1274 lfsmake2 GD-Graph
1275 lfsmake2 GD-TextUtil
1276 lfsmake2 perl-Device-SerialPort
1277 lfsmake2 perl-Device-Modem
1278 lfsmake2 perl-Apache-Htpasswd
1279 lfsmake2 perl-Parse-Yapp
1280 lfsmake2 perl-Data-UUID
1281 lfsmake2 gnupg
1282 lfsmake2 hdparm
1283 lfsmake2 sdparm
1284 lfsmake2 whatmask
1285 lfsmake2 libtirpc
1286 lfsmake2 conntrack-tools
1287 lfsmake2 iputils
1288 lfsmake2 l7-protocols
1289 lfsmake2 hwdata
1290 lfsmake2 logrotate
1291 lfsmake2 logwatch
1292 lfsmake2 misc-progs
1293 lfsmake2 nano
1294 lfsmake2 URI
1295 lfsmake2 perl-CGI
1296 lfsmake2 perl-Switch
1297 lfsmake2 HTML-Tagset
1298 lfsmake2 HTML-Parser
1299 lfsmake2 HTML-Template
1300 lfsmake2 Compress-Zlib
1301 lfsmake2 Digest
1302 lfsmake2 Digest-SHA1
1303 lfsmake2 Digest-HMAC
1304 lfsmake2 libwww-perl
1305 lfsmake2 Net-DNS
1306 lfsmake2 Net-IPv4Addr
1307 lfsmake2 Net_SSLeay
1308 lfsmake2 IO-Stringy
1309 lfsmake2 IO-Socket-SSL
1310 lfsmake2 Unix-Syslog
1311 lfsmake2 Mail-Tools
1312 lfsmake2 MIME-Tools
1313 lfsmake2 Net-Server
1314 lfsmake2 Canary-Stability
1315 lfsmake2 Convert-TNEF
1316 lfsmake2 Convert-UUlib
1317 lfsmake2 Archive-Tar
1318 lfsmake2 Archive-Zip
1319 lfsmake2 Text-Tabs+Wrap
1320 lfsmake2 XML-Parser
1321 lfsmake2 Crypt-PasswdMD5
1322 lfsmake2 Net-Telnet
1323 lfsmake2 python3-setuptools
1324 lfsmake2 python3-inotify
1325 lfsmake2 python3-docutils
1326 lfsmake2 python3-daemon
1327 lfsmake2 glib
1328 lfsmake2 ntp
1329 lfsmake2 openssh
1330 lfsmake2 fontconfig
1331 lfsmake2 dejavu-fonts-ttf
1332 lfsmake2 ubuntu-font-family
1333 lfsmake2 freefont
1334 lfsmake2 pixman
1335 lfsmake2 cairo
1336 lfsmake2 pango
1337 lfsmake2 rrdtool
1338 lfsmake2 setup
1339 lfsmake2 libdnet
1340 lfsmake2 rust
1341 lfsmake2 jansson
1342 lfsmake2 yaml
1343 lfsmake2 libhtp
1344 lfsmake2 colm
1345 lfsmake2 ragel
1346 lfsmake2 hyperscan
1347 lfsmake2 suricata
1348 lfsmake2 oinkmaster
1349 lfsmake2 ids-ruleset-sources
1350 lfsmake2 squid
1351 lfsmake2 squidguard
1352 lfsmake2 calamaris
1353 lfsmake2 tcpdump
1354 lfsmake2 traceroute
1355 lfsmake2 vlan
1356 lfsmake2 wireless
1357 lfsmake2 pakfire
1358 lfsmake2 spandsp
1359 lfsmake2 lz4
1360 lfsmake2 lzo
1361 lfsmake2 openvpn
1362 lfsmake2 mpage
1363 lfsmake2 dbus
1364 lfsmake2 intltool
1365 lfsmake2 libdaemon
1366 lfsmake2 avahi
1367 lfsmake2 cups
1368 lfsmake2 lcms2
1369 lfsmake2 ghostscript
1370 lfsmake2 qpdf
1371 lfsmake2 poppler
1372 lfsmake2 poppler-data
1373 lfsmake2 cups-filters
1374 lfsmake2 epson-inkjet-printer-escpr
1375 lfsmake2 foomatic
1376 lfsmake2 hplip
1377 lfsmake2 cifs-utils
1378 lfsmake2 krb5
1379 lfsmake2 rpcsvc-proto
1380 lfsmake2 samba
1381 lfsmake2 netatalk
1382 lfsmake2 sudo
1383 lfsmake2 mc
1384 lfsmake2 wget
1385 lfsmake2 bridge-utils
1386 lfsmake2 smartmontools
1387 lfsmake2 htop
1388 lfsmake2 chkconfig
1389 lfsmake2 postfix
1390 lfsmake2 fetchmail
1391 lfsmake2 clamav
1392 lfsmake2 perl-NetAddr-IP
1393 lfsmake2 dma
1394 lfsmake2 alsa
1395 lfsmake2 mpfire
1396 lfsmake2 guardian
1397 lfsmake2 libid3tag
1398 lfsmake2 libmad
1399 lfsmake2 libogg
1400 lfsmake2 libvorbis
1401 lfsmake2 flac
1402 lfsmake2 lame
1403 lfsmake2 sox
1404 lfsmake2 soxr
1405 lfsmake2 libshout
1406 lfsmake2 xvid
1407 lfsmake2 libmpeg2
1408 lfsmake2 gnump3d
1409 lfsmake2 rsync
1410 lfsmake2 rpcbind
1411 lfsmake2 keyutils
1412 lfsmake2 libnfsidmap
1413 lfsmake2 nfs
1414 lfsmake2 gnu-netcat
1415 lfsmake2 ncat
1416 lfsmake2 nmap
1417 lfsmake2 etherwake
1418 lfsmake2 bwm-ng
1419 lfsmake2 sysstat
1420 lfsmake2 strongswan
1421 lfsmake2 rng-tools
1422 lfsmake2 lsof
1423 lfsmake2 br2684ctl
1424 lfsmake2 pcmciautils
1425 lfsmake2 lm_sensors
1426 lfsmake2 libstatgrab
1427 lfsmake2 liboping
1428 lfsmake2 collectd
1429 lfsmake2 elinks
1430 lfsmake2 igmpproxy
1431 lfsmake2 opus
1432 lfsmake2 python3-pyparsing
1433 lfsmake2 spice-protocol
1434 lfsmake2 spice
1435 lfsmake2 sdl2
1436 lfsmake2 libusbredir
1437 lfsmake2 libseccomp
1438 lfsmake2 qemu
1439 lfsmake2 netpbm
1440 lfsmake2 netsnmpd
1441 lfsmake2 nagios_nrpe
1442 lfsmake2 nagios-plugins
1443 lfsmake2 icinga
1444 lfsmake2 observium-agent
1445 lfsmake2 ebtables
1446 lfsmake2 faad2
1447 lfsmake2 alac
1448 lfsmake2 ffmpeg
1449 lfsmake2 vdr
1450 lfsmake2 vdr_streamdev
1451 lfsmake2 vdr_epgsearch
1452 lfsmake2 vdr_dvbapi
1453 lfsmake2 vdr_eepg
1454 lfsmake2 w_scan
1455 lfsmake2 mpd
1456 lfsmake2 libmpdclient
1457 lfsmake2 mpc
1458 lfsmake2 perl-Net-CIDR-Lite
1459 lfsmake2 perl-Net-SMTP-SSL
1460 lfsmake2 perl-MIME-Base64
1461 lfsmake2 perl-Authen-SASL
1462 lfsmake2 perl-MIME-Lite
1463 lfsmake2 perl-Email-Date-Format
1464 lfsmake2 git
1465 lfsmake2 squidclamav
1466 lfsmake2 vnstat
1467 lfsmake2 iw
1468 lfsmake2 wpa_supplicant
1469 lfsmake2 hostapd
1470 lfsmake2 syslinux
1471 lfsmake2 tftpd
1472 lfsmake2 cpufrequtils
1473 lfsmake2 gutenprint
1474 lfsmake2 apcupsd
1475 lfsmake2 fireperf
1476 lfsmake2 iperf
1477 lfsmake2 iperf3
1478 lfsmake2 7zip
1479 lfsmake2 lynis
1480 lfsmake2 sshfs
1481 lfsmake2 taglib
1482 lfsmake2 sslh
1483 lfsmake2 perl-gettext
1484 lfsmake2 perl-Sort-Naturally
1485 lfsmake2 vdradmin
1486 lfsmake2 perl-DBI
1487 lfsmake2 perl-DBD-SQLite
1488 lfsmake2 perl-File-ReadBackwards
1489 lfsmake2 openvmtools
1490 lfsmake2 joe
1491 lfsmake2 monit
1492 lfsmake2 nut
1493 lfsmake2 watchdog
1494 lfsmake2 libpri
1495 lfsmake2 usb_modeswitch
1496 lfsmake2 usb_modeswitch_data
1497 lfsmake2 zerofree
1498 lfsmake2 minicom
1499 lfsmake2 ddrescue
1500 lfsmake2 powertop
1501 lfsmake2 parted
1502 lfsmake2 swig
1503 lfsmake2 dtc
1504 lfsmake2 u-boot
1505 lfsmake2 u-boot-friendlyarm
1506 lfsmake2 wireless-regdb
1507 lfsmake2 libsolv
1508 lfsmake2 ddns
1509 lfsmake2 python3-setuptools-scm
1510 lfsmake2 python3-six
1511 lfsmake2 python3-dateutil
1512 lfsmake2 python3-jmespath
1513 lfsmake2 python3-colorama
1514 lfsmake2 python3-yaml
1515 lfsmake2 python3-s3transfer
1516 lfsmake2 python3-rsa
1517 lfsmake2 python3-pyasn1
1518 lfsmake2 python3-urllib3
1519 lfsmake2 python3-botocore
1520 lfsmake2 python3-msgpack
1521 lfsmake2 aws-cli
1522 lfsmake2 transmission
1523 lfsmake2 mtr
1524 lfsmake2 minidlna
1525 lfsmake2 acpid
1526 lfsmake2 fping
1527 lfsmake2 telnet
1528 lfsmake2 xinetd
1529 lfsmake2 stress
1530 lfsmake2 sarg
1531 lfsmake2 nginx
1532 lfsmake2 sysbench
1533 lfsmake2 strace
1534 lfsmake2 ltrace
1535 lfsmake2 ipfire-netboot
1536 lfsmake2 lcdproc
1537 lfsmake2 keepalived
1538 lfsmake2 ipvsadm
1539 lfsmake2 perl-Carp-Clan
1540 lfsmake2 perl-Date-Calc
1541 lfsmake2 perl-Date-Manip
1542 lfsmake2 perl-File-Tail
1543 lfsmake2 perl-TimeDate
1544 lfsmake2 swatch
1545 lfsmake2 tor
1546 lfsmake2 wavemon
1547 lfsmake2 iptraf-ng
1548 lfsmake2 iotop
1549 lfsmake2 stunnel
1550 lfsmake2 bacula
1551 lfsmake2 perl-Font-TTF
1552 lfsmake2 perl-IO-String
1553 lfsmake2 perl-PDF-API2
1554 lfsmake2 squid-accounting
1555 lfsmake2 pigz
1556 lfsmake2 tmux
1557 lfsmake2 perl-Text-CSV_XS
1558 lfsmake2 lua
1559 lfsmake2 haproxy
1560 lfsmake2 ipset
1561 lfsmake2 dnsdist
1562 lfsmake2 bird
1563 lfsmake2 libyang
1564 lfsmake2 frr
1565 lfsmake2 dmidecode
1566 lfsmake2 mcelog
1567 lfsmake2 util-macros
1568 lfsmake2 libpciaccess
1569 lfsmake2 libyajl
1570 lfsmake2 libvirt
1571 lfsmake2 libtalloc
1572 lfsmake2 freeradius
1573 lfsmake2 perl-common-sense
1574 lfsmake2 perl-inotify2
1575 lfsmake2 perl-Net-IP
1576 lfsmake2 wio
1577 lfsmake2 iftop
1578 lfsmake2 mdns-repeater
1579 lfsmake2 i2c-tools
1580 lfsmake2 nss-myhostname
1581 lfsmake2 dehydrated
1582 lfsmake2 shairport-sync
1583 lfsmake2 borgbackup
1584 lfsmake2 lmdb
1585 lfsmake2 knot
1586 lfsmake2 spectre-meltdown-checker
1587 lfsmake2 zabbix_agentd
1588 lfsmake2 flashrom
1589 lfsmake2 firmware-update
1590 lfsmake2 tshark
1591 lfsmake2 speedtest-cli
1592 lfsmake2 rfkill
1593 lfsmake2 amazon-ssm-agent
1594 lfsmake2 libloc
1595 lfsmake2 ncdu
1596 lfsmake2 lshw
1597 lfsmake2 socat
1598 lfsmake2 libcdada
1599 lfsmake2 pmacct
1600 lfsmake2 squid-asnbl
1601 }
1602
1603 buildinstaller() {
1604 # Run installer scripts one by one
1605 LOGFILE="$BASEDIR/log/_build.installer.log"
1606 export LOGFILE
1607 lfsmake2 memtest
1608 lfsmake2 installer
1609 # use toolchain bash for chroot to strip
1610 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1611 }
1612
1613 buildpackages() {
1614 LOGFILE="$BASEDIR/log/_build.packages.log"
1615 export LOGFILE
1616 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1617
1618
1619 # Generating list of packages used
1620 print_line "Generating packages list from logs"
1621 rm -f $BASEDIR/doc/packages-list
1622 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1623 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1624 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1625 fi
1626 done
1627 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1628 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1629 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1630 rm -f $BASEDIR/doc/packages-list
1631 # packages-list.txt is ready to be displayed for wiki page
1632 print_status DONE
1633
1634 # Update changelog
1635 cd $BASEDIR
1636 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1637 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1638 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1639
1640 # Create images for install
1641 lfsmake2 cdrom
1642
1643 # Check if there is a loop device for building in virtual environments
1644 modprobe loop 2>/dev/null
1645 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1646 lfsmake2 flash-images
1647 fi
1648
1649 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1650
1651 ipfirepackages
1652
1653 cd $BASEDIR
1654
1655 # remove not useable iso on armv6l (needed to build flash images)
1656 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
1657
1658 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
1659 md5sum $i > $i.md5
1660 done
1661 cd $PWD
1662
1663 # Cleanup
1664 stdumount
1665 rm -rf $BASEDIR/build/tmp/*
1666
1667 cd $PWD
1668 }
1669
1670 ipfirepackages() {
1671 lfsmake2 core-updates
1672
1673 local i
1674 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1675 i=$(basename ${i})
1676 if [ -e $BASEDIR/lfs/$i ]; then
1677 ipfiredist $i
1678 else
1679 echo -n $i
1680 print_status SKIP
1681 fi
1682 done
1683 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1684 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1685 rm -rf $BASEDIR/build/install/packages/*
1686 }
1687
1688 while [ $# -gt 0 ]; do
1689 case "${1}" in
1690 --target=*)
1691 configure_build "${1#--target=}"
1692 ;;
1693 -*)
1694 exiterror "Unknown configuration option: ${1}"
1695 ;;
1696 *)
1697 # Found a command, so exit options parsing.
1698 break
1699 ;;
1700 esac
1701 shift
1702 done
1703
1704 # See what we're supposed to do
1705 case "$1" in
1706 build)
1707 START_TIME=$(now)
1708
1709 # Clear screen
1710 ${INTERACTIVE} && clear
1711
1712 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
1713 #only restore on a clean disk
1714 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1715 if [ ! -n "$PACKAGE" ]; then
1716 print_build_stage "Full toolchain compilation"
1717 prepareenv
1718 buildtoolchain
1719 else
1720 PACKAGENAME=${PACKAGE%.tar.zst}
1721 print_build_stage "Packaged toolchain compilation"
1722 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1723 zstd -d < "${PACKAGE}" | tar x
1724 prepareenv
1725 else
1726 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1727 fi
1728 fi
1729 else
1730 prepareenv
1731 fi
1732
1733 print_build_stage "Building LFS"
1734 buildbase
1735
1736 print_build_stage "Building IPFire"
1737 buildipfire
1738
1739 print_build_stage "Building installer"
1740 buildinstaller
1741
1742 print_build_stage "Building packages"
1743 buildpackages
1744
1745 print_build_stage "Checking Logfiles for new Files"
1746
1747 cd $BASEDIR
1748 tools/checknewlog.pl
1749 tools/checkrootfiles
1750 cd $PWD
1751
1752 print_build_summary $(( $(now) - ${START_TIME} ))
1753 ;;
1754 shell)
1755 # enter a shell inside LFS chroot
1756 # may be used to changed kernel settings
1757 prepareenv
1758 entershell
1759 ;;
1760 clean)
1761 print_line "Cleaning build directory..."
1762
1763 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1764 $LOSETUP -d $i 2>/dev/null
1765 done
1766 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1767 # umount $i
1768 #done
1769 stdumount
1770 for i in `seq 0 7`; do
1771 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1772 umount /dev/loop${i} 2>/dev/null;
1773 losetup -d /dev/loop${i} 2>/dev/null;
1774 fi;
1775 done
1776 rm -rf $BASEDIR/build
1777 rm -rf $BASEDIR/cdrom
1778 rm -rf $BASEDIR/packages
1779 rm -rf $BASEDIR/log
1780 if [ -h "${TOOLS_DIR}" ]; then
1781 rm -f "${TOOLS_DIR}"
1782 fi
1783 rm -f $BASEDIR/ipfire-*
1784 print_status DONE
1785 ;;
1786 docker)
1787 # Build the docker image if it does not exist, yet
1788 if ! docker images -a | grep -q ^ipfire-builder; then
1789 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1790 print_status DONE
1791 else
1792 print_status FAIL
1793 exit 1
1794 fi
1795 fi
1796
1797 # Run the container and enter a shell
1798 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1799 ;;
1800 downloadsrc)
1801 if [ ! -d $BASEDIR/cache ]; then
1802 mkdir $BASEDIR/cache
1803 fi
1804 mkdir -p $BASEDIR/log
1805 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1806 FINISHED=0
1807 cd $BASEDIR/lfs
1808 for c in `seq $MAX_RETRIES`; do
1809 if (( FINISHED==1 )); then
1810 break
1811 fi
1812 FINISHED=1
1813 cd $BASEDIR/lfs
1814 for i in *; do
1815 if [ -f "$i" -a "$i" != "Config" ]; then
1816 lfsmakecommoncheck ${i} || continue
1817
1818 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1819 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1820 if [ $? -ne 0 ]; then
1821 print_status FAIL
1822 FINISHED=0
1823 else
1824 if [ $c -eq 1 ]; then
1825 print_status DONE
1826 fi
1827 fi
1828 fi
1829 done
1830 done
1831 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1832 ERROR=0
1833 for i in *; do
1834 if [ -f "$i" -a "$i" != "Config" ]; then
1835 lfsmakecommoncheck ${i} > /dev/null || continue
1836 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1837 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1838 if [ $? -ne 0 ]; then
1839 echo -ne "MD5 difference in lfs/$i"
1840 print_status FAIL
1841 ERROR=1
1842 fi
1843 fi
1844 done
1845 if [ $ERROR -eq 0 ]; then
1846 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1847 print_status DONE
1848 else
1849 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1850 print_status FAIL
1851 fi
1852 cd - >/dev/null 2>&1
1853 ;;
1854 toolchain)
1855 # Clear screen
1856 ${INTERACTIVE} && clear
1857
1858 prepareenv
1859 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1860 buildtoolchain
1861 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1862 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1863 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1864 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1865 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
1866 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1867 stdumount
1868 ;;
1869 gettoolchain)
1870 # arbitrary name to be updated in case of new toolchain package upload
1871 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1872 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
1873 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1874 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1875 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1876 cd $BASEDIR/cache/toolchains
1877 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1878 if [ $? -ne 0 ]; then
1879 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1880 else
1881 if [ "`md5sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1882 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1883 else
1884 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1885 fi
1886 fi
1887 else
1888 echo "Toolchain is already downloaded. Exiting..."
1889 fi
1890 ;;
1891 uploadsrc)
1892 if [ -z $IPFIRE_USER ]; then
1893 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1894 print_status FAIL
1895 exit 1
1896 fi
1897
1898 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
1899
1900 rsync \
1901 --recursive \
1902 --update \
1903 --ignore-existing \
1904 --progress \
1905 --human-readable \
1906 --exclude="toolchains/" \
1907 "${BASEDIR}/cache/" \
1908 "${IPFIRE_USER}@${URL_SOURCE}"
1909
1910 exit 0
1911 ;;
1912 lang)
1913 echo -ne "Checking the translations for missing or obsolete strings..."
1914 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1915 $BASEDIR/tools/sort_strings.pl en
1916 $BASEDIR/tools/sort_strings.pl de
1917 $BASEDIR/tools/sort_strings.pl fr
1918 $BASEDIR/tools/sort_strings.pl es
1919 $BASEDIR/tools/sort_strings.pl pl
1920 $BASEDIR/tools/sort_strings.pl ru
1921 $BASEDIR/tools/sort_strings.pl nl
1922 $BASEDIR/tools/sort_strings.pl tr
1923 $BASEDIR/tools/sort_strings.pl it
1924 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1925 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1926 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1927 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1928 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
1929 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1930 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1931 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1932 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1933 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1934 print_status DONE
1935
1936 echo -ne "Updating language lists..."
1937 update_language_list ${BASEDIR}/src/installer/po
1938 update_language_list ${BASEDIR}/src/setup/po
1939 print_status DONE
1940 ;;
1941 update-contributors)
1942 update_contributors
1943 ;;
1944 find-dependencies)
1945 shift
1946 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
1947 ;;
1948 check-manualpages)
1949 echo "Checking the manual pages for broken links..."
1950
1951 chmod 755 $BASEDIR/tools/check_manualpages.pl
1952 if $BASEDIR/tools/check_manualpages.pl; then
1953 print_status DONE
1954 else
1955 print_status FAIL
1956 fi
1957 ;;
1958 *)
1959 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies|check-manualpages}"
1960 cat doc/make.sh-usage
1961 ;;
1962 esac
1963